#!/usr/bin/env node
/********************************************************* {COPYRIGHT-TOP} ***
 * Licensed Materials - Property of IBM
 * 5725-Z22, 5725-Z63, 5725-U33, 5725-Z63
 *
 * (C) Copyright IBM Corporation 2016, 2017
 *
 * All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ********************************************************** {COPYRIGHT-END} **/
// Node module: apiconnect-cli-create


// Note: This file delays all require statements till runtime as it directly impacts
// cli load time.

var g = require('strong-globalize')();

module.exports = {
  name: 'create',
  version: require('../package.json').version,
  path: __filename,
  isBuiltin: true,
  topics: getTopics,
};

function getTopics() {
  return [ {
    name: 'local',
    helpInfo: function() {
      return g.f('apic_local_help.txt');
    },
    commands: [ {
      command: 'create',
      aliases: [ 'create' ],
      helpInfo: function() {
        return g.f('apic_local_create_api_help.txt');
      },
      action: function(opts) {
        var actions = require('./actions');
        return actions.createApi(opts);
      },
      type: 'api',
      options: [
        '--title <title>',
        '--name <name>',
        '-v, --version <version>',
        '--basepath <basepath>',
        '--product <product_title>',
        '--template <template>',
        '--filename <filename>',
        '--hostname <hostname>',
        '--schemes <schemes>',
        '--target-url <targetUrl>',
        '--wsdl <wsdl>',
      ],
    }, {
      command: 'create',
      aliases: [ 'create' ],
      helpInfo: function() {
        return g.f('apic_local_create_product_help.txt');
      },
      action: function(opts) {
        var actions = require('./actions');
        return actions.createProduct(opts);
      },
      type: 'product',
      options: [
        '--title <title>',
        '--name <name>',
        '-v, --version <version>',
        '--basepath <basepath>',
        '--product <product_title>',
        '--template <template>',
        '--filename <filename>',
        '--apis <api_filename ...>',
      ],
    } ],
  } ];
};

