/********************************************************* {COPYRIGHT-TOP} ***
 * Licensed Materials - Property of IBM
 * 5725-Z22, 5725-Z63, 5725-U33, 5725-Z63
 *
 * (C) Copyright IBM Corporation 2016, 2017
 *
 * All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ********************************************************** {COPYRIGHT-END} **/
// Node module: apiconnect-cli-create

var Chance = require('chance');

var PREFIX = 'api-';

function generateSlugFromText(text) {
  if (!text) {
    return generateRandomSlug(PREFIX);
  }

  // In case the filename is a number, this will turn text into string
  text += '';

  // Remove the intial and ending spaces
  text = text.trim();

  //transform spaces to dash
  text = text.replace(/\s+/g, '-');

  //remove any characters that are not a-zA-Z_-0-9
  text = text.replace(/[^A-Za-z_\-0-9]/g, '');

  //make all text lowercase
  text = text.toLowerCase();

  if (text === '' || text === '-') {
    return generateRandomSlug(PREFIX);
  }

  return text;
}

function generateRandomSlug(prefix) {
  var randomWord = new Chance();
  var uniqueText = randomWord.word({ length: 5 });
  return prefix + uniqueText;
}

module.exports.generateSlugFromText = generateSlugFromText;

